# IGuest Interface Reference

The IGuest interface represents information about the operating system running inside the virtual machine. More...

List of all members.

## Public Member Functions
void | setCredentials (in wstring userName, in wstring password, in wstring domain, in boolean allowInteractiveLogon)
| Store login credentials that can be queried by guest operating systems with Additions installed.
void | getStatistic (in unsigned long cpuId, in GuestStatisticType statistic,[retval] out unsigned long statVal)
| Query specified guest statistics as reported by the VirtualBox Additions.
## Public Attributes
readonly attribute wstring | OSTypeId
| Identifier of the Guest OS type as reported by the Guest Additions.
readonly attribute boolean | additionsActive
| Flag whether the Guest Additions are installed and active in which case their version will be returned by the additionsVersion property.
readonly attribute wstring | additionsVersion
| Version of the Guest Additions (3 decimal numbers separated by dots) or empty when the Additions are not installed.
readonly attribute boolean | supportsSeamless
| Flag whether seamless guest display rendering (seamless desktop integration) is supported.
readonly attribute boolean | supportsGraphics
| Flag whether the guest is in graphics mode.
attribute unsigned long | memoryBalloonSize
| Guest system memory balloon size in megabytes.
attribute unsigned long | statisticsUpdateInterval
| Interval to update guest statistics in seconds.

## Detailed Description

The IGuest interface represents information about the operating system running inside the virtual machine.

Used in IConsole::guest.

IGuest provides information about the guest operating system, whether Guest Additions are installed and other OS-specific virtual machine properties.

Interface ID:
  `{D8556FCA-81BC-12AF-FCA3-365528FA38CA}`

## Member Function Documentation

void IGuest::setCredentials | ( | in wstring | userName,
|  | in wstring | password,
|  | in wstring | domain,
|  | in boolean | allowInteractiveLogon |
| ) |  |  |

Store login credentials that can be queried by guest operating systems with Additions installed.

The credentials are transient to the session and the guest may also choose to erase them. Note that the caller cannot determine whether the guest operating system has queried or made use of the credentials.

Parameters:

  | userName | User name string, can be empty
  | password | Password string, can be empty
  | domain | Domain name (guest logon scheme specific), can be empty
  | allowInteractiveLogon | Flag whether the guest should alternatively allow the user to interactively specify different credentials. This flag might not be supported by all versions of the Additions.

Expected result codes:

  VBOX_E_VM_ERROR | VMM device is not available.

void IGuest::getStatistic | ( | in unsigned long | cpuId,
|  | in GuestStatisticType | statistic,
|  | [retval] out unsigned long | statVal |
| ) |  |  |

Query specified guest statistics as reported by the VirtualBox Additions.

Parameters:

  | cpuId | Virtual CPU id; not relevant for all statistic types
  | statistic | Statistic type.
  | statVal | Statistics value

## Member Data Documentation

readonly attribute wstring IGuest::OSTypeId

Identifier of the Guest OS type as reported by the Guest Additions.

You may use IVirtualBox::getGuestOSType to obtain an IGuestOSType object representing details about the given Guest OS type.

Note:
  If Guest Additions are not installed, this value will be the same as IMachine::OSTypeId.

readonly attribute boolean IGuest::additionsActive

Flag whether the Guest Additions are installed and active in which case their version will be returned by the additionsVersion property.

readonly attribute wstring IGuest::additionsVersion

Version of the Guest Additions (3 decimal numbers separated by dots) or empty when the Additions are not installed.

The Additions may also report a version but yet not be active as the version might be refused by VirtualBox (incompatible) or other failures occurred.

readonly attribute boolean IGuest::supportsSeamless

Flag whether seamless guest display rendering (seamless desktop integration) is supported.

readonly attribute boolean IGuest::supportsGraphics

Flag whether the guest is in graphics mode.

If it is not, then seamless rendering will not work, resize hints are not immediately acted on and guest display resizes are probably not initiated by the guest additions.

attribute unsigned long IGuest::memoryBalloonSize

Guest system memory balloon size in megabytes.

attribute unsigned long IGuest::statisticsUpdateInterval

Interval to update guest statistics in seconds.